<template>
  <section id="signIn">
    <AlertBox ref="alertBox" />
    <div class="sign-in-form-card col">
      <form>
        <div class="sign-in-title">เข้าสู่ระบบ</div>
        <v-text-field
          v-model="email"
          @keyup.enter="signIn"
          :error-messages="emailErrors"
          label="อีเมล"
          required
          outlined
        ></v-text-field>
        <v-text-field
          v-model="password"
          @keyup.enter="signIn"
          :append-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"
          :type="showPassword ? 'text' : 'password'"
          :error-messages="passwordErrors"
          label="รหัสผ่าน"
          required
          outlined
          class="input-group--focused"
          @click:append="showPassword = !showPassword"
        ></v-text-field>
        <v-sheet class="text-center" height="auto">
          <v-btn
            width="150px"
            height="50px"
            color="blue"
            dark
            :loading="loadingBeforeSignIn"
            @click="signIn"
          >Sign In</v-btn>
        </v-sheet>
      </form>
    </div>
  </section>
</template>

<script>
import { mapActions } from 'vuex'
import { validationMixin } from "vuelidate";
import { required, email } from "vuelidate/lib/validators";
import AlertBox from '~/components/general/alert-box/AlertBox'
import firebase from 'firebase/app';
import 'firebase/auth';

export default {
  name: "signin",
  mixins: [validationMixin],
  validations: {
    email: { required, email },
    password: { required }
  },
  components: {
    AlertBox
  },
  data() {
    return {
      email: "",
      password: "",
      showPassword: false,
      loadingBeforeSignIn: false,
    };
  },
  computed: {
    emailErrors() {
      const errors = [];
      if (!this.$v.email.$dirty) return errors
      !this.$v.email.email && errors.push('กรุณากรอกอีเมลให้ครบถ้วน')
      !this.$v.email.required && errors.push('กรุณากรอกอีเมล')
      return errors
    },
    passwordErrors() {
      const errors = [];
      if (!this.$v.password.$dirty) return errors;
      !this.$v.password.required && errors.push("กรุณากรอกรหัสผ่าน");
      return errors;
    }
  },
  methods: {
    ...mapActions({
      addProfile: 'setSignIn'
    }),
    showAlert: function (value) {
      const vm = this
      const alert = {
        'mainTitle': value.title,
        'subTitle': value.text,
        'type': value.type,
        'time': value.time,
        'autoClose': value.autoClose,
        'show': value.show
      }
      vm.$refs.alertBox.showBox(alert)
    },
    getProfile () {
      const vm = this
      const auth = firebase.auth()
      auth.onAuthStateChanged((user) => {
        if (user) {
          let newProfile = {
            email: user.email,
            uid: user.uid,
            emailVerified: user.emailVerified
          }
          vm.addProfile('setSignIn', newProfile)
          vm.$nextTick(() => {
            vm.loadingBeforeSignIn = false
            vm.$emit('login', { isLogin: true, profile: newProfile })
          })
        }
      })
    },
    signIn () {
      const vm = this
      vm.$v.$touch()
      vm.loadingBeforeSignIn = true
      if (!vm.emailErrors[0] && !vm.passwordErrors[0]) {
        const auth = firebase.auth()
        auth.signInWithEmailAndPassword(vm.email, vm.password)
          .then((res) => {
            vm.getProfile()
            // vm.$nuxt.$router.push('/dashboard')
          })
          .catch((e) => {
            vm.showAlert({ title: 'ไม่สามารถเข้าระบบได้!',
              text: 'เนื่องจากอีเมลหรือรหัสผ่านไม่ถูกต้อง', type: 'error',
              time: 5, autoClose: true, show: true })
          })
      }
    }
  }
};
</script>
<style lang="scss" scoped>
#signIn {
  position: relative;
  width: 100%;
  height: 100%;
  background: url("~@/assets/images/bg-login.jpg") no-repeat;
  background-size: 100% 100%;
  .sign-in-form-card {
    position: absolute;
    max-width: 450px;
    max-height: 400px;
    background-color: white;
    border-radius: 15px;
    margin: auto;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    transition: box-shadow 0.28s cubic-bezier(0.4, 0, 0.2, 1);
    will-change: box-shadow;
    box-shadow: 0 3px 1px -2px rgba(0, 0, 0, 0.2),
      0 2px 2px 0 rgba(0, 0, 0, 0.14), 0 1px 5px 0 rgba(0, 0, 0, 0.12);
    .sign-in-title {
      text-align: center;
      margin: 30px;
      font-size: 36px;
    }
  }
}
</style>
